/*
	*
	* This file is a part of libpaperde.
	* Library for handling various services related to Paper Desktop
	* Copyright 2020 CuboCore Group
	*

	*
	* This program is free software; you can redistribute it and/or modify
	* it under the terms of the GNU General Public License as published by
	* the Free Software Foundation; either version 3 of the License, or
	* (at your option) any later version.
	*

	*
	* This program is distributed in the hope that it will be useful,
	* but WITHOUT ANY WARRANTY; without even the implied warranty of
	* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	* GNU General Public License for more details.
	*

	*
	* You should have received a copy of the GNU General Public License
	* along with this program; if not, write to the Free Software
	* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
	* MA 02110-1301, USA.
	*
*/

#pragma once

#include <QObject>

#include "aixlog.h"

#define MESSAGECONV(msg) QString(msg).toStdString() << "\n"

#define PTRACE(msg) LOG(TRACE) << MESSAGECONV(msg)
#define PDEBUG(msg) LOG(DEBUG) << MESSAGECONV(msg)
#define PINFO(msg) LOG(INFO) << MESSAGECONV(msg)
#define PNOTICE(msg) LOG(NOTICE) << MESSAGECONV(msg)
#define PWARNING(msg) LOG(WARNING) << MESSAGECONV(msg)
#define PERROR(msg) LOG(ERROR) << MESSAGECONV(msg)
#define PFATAL(msg) LOG(FATAL) << MESSAGECONV(msg)

class paperLog {
public:
	explicit paperLog(const QString &appName);
	static QString paperLogDir(const QString &appName);
	static void paperLogger(QtMsgType type, const QMessageLogContext &context, const QString &message);
};
